package org.zipcoder.store;

import java.util.ArrayList;
import java.util.List;

public class ListMap implements MyMap {
    // instance field that is intialize to an ArrayList
    private List<Entry> entries = new ArrayList<>();

    @Override
    public int size() {

        return entries.size();
    }

    @Override
    public boolean isEmptry() {

        return entries.size() == 0;
    }

    @Override
    public Cart get(User key) {
        // find the cart associate with the key
        for(Entry e: entries){
            if(e.getKey().equals(key)){
                return e.getValue();
            }
        }
        return null;
    }

    @Override
    public void put(User key, Cart value) {
        // add the key, value entry to the entries list
        if(get(key) == null){
            entries.add(new Entry(key, value));
        } else {
            for(Entry e: entries) {
                if(e.getKey().equals(key)){
                    e.setValue(value);
                }
            }
        }
    }


    @Override
    public List<User> getKeys() {
        // get all the keys in the map
        List<User> users = new ArrayList<User>();
        for(Entry e: entries) {
            users.add(e.getKey());
        }
        return users;
    }

    @Override
    public List<Cart> getValues() {
        // get all the values in the map
        List<Cart> carts = new ArrayList<Cart>();
        for(Entry e: entries){
            carts.add(e.getValue());
        }
        return carts;
    }

    @Override
    public Cart remove(User key) {
        Cart gone = null;
        for(Entry e: entries){
            if(e.getKey().equals(key)){
                gone = e.getValue();
                entries.remove(e);
            }
        }
        return gone;
    }
}
