package org.zipcoder.store;

import java.util.*;

public class MyHashMap implements MyMap{
    // final field that doesn't change for any object
    private static final int BUCKET_SIZE = 15;

    // instance field that can only be set once. It is different for every Object
    private final List<Entry>[] entries;

    public MyHashMap(){
        entries = new List[BUCKET_SIZE];

        for(int i = 0; i < BUCKET_SIZE; i++) {
            entries[i] = new ArrayList<>();
        }
    }

    @Override
    public int size() {
        int total = 0;
        for(List<Entry> e: entries){
            total += e.size();
        }
        return total;
    }

    @Override
    public boolean isEmptry() {
        if (size() == 0) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public Cart get(User key) {
        Cart cart = null;
        List<Entry> entryList = entries[bucketIndex(key)];
        for (Entry e : entryList) {
            if (e.getKey().equals(key)) {
                cart = e.getValue();
                }
        }
        return cart;

    }

    @Override
    public void put(User key, Cart value) {
        entries[bucketIndex(key)].add(new Entry(key,value));
    }

    @Override
    public List<User> getKeys() {
        List<User> users = new ArrayList<User>();
        for(List<Entry> entryList: entries){
            for(Entry entry: entryList){
                users.add(entry.getKey());
            }
        }
        return users;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> carts = new ArrayList<Cart>();
        for (List<Entry> entryList : entries) {
            for (Entry entry : entryList) {
                carts.add(entry.getValue());
            }
        }
        return carts;
    }

    @Override
    public Cart remove(User key) {
        List<Entry> bin = entries[bucketIndex(key)];
        Iterator<Entry> iterator = bin.iterator();

        Cart removedCart = null;

        while(iterator.hasNext()) {
            Entry entry = iterator.next();
            if (entry.getKey().equals(key)) {
                removedCart = entry.getValue();
                iterator.remove();
            }
        }
        return removedCart;
    }

    private int bucketIndex(User key){
        return Math.abs(key.hashCode()) % entries.length;
    }

        private int keyIndex(List<Entry> bin, User key) {
        int index = -1;
        for (int i = 0; i < bin.size(); i++) {
            if (bin.get(i).getKey().equals(key)) {
                index = i;
            }
        }
        return index;
    }
}
